uniform mat4 uMVP;
uniform mat4 uNormalMatrix;

attribute vec4 aPosition;
attribute vec3 aNormal;  
attribute vec2 aTexCoord;
attribute vec4 aColour;

varying vec2 vTexCoord;
varying vec3 vNormal;
varying vec3 eyespaceNormal;

void main()                    
{                            
    vTexCoord = aTexCoord;
    vNormal = aNormal;
    
    // normal
	eyespaceNormal = vec3(uNormalMatrix * vec4(aNormal, 1.0));
    	  	  
    gl_Position = uMVP * aPosition;    
}          