// Pixel shader to generate the Depth Map
// Used for shadow mapping - generates depth map from the light's viewpoint

#ifdef GL_ES
precision mediump float;
#endif

varying vec4 vPosition; 

// taken from Fabien Sangalard's DEngine 
vec4 pack (float depth)
{
	const vec4 bitSh = vec4(256.0 * 256.0 * 256.0,
							256.0 * 256.0,
							256.0,
							1.0);
	const vec4 bitMsk = vec4(0,
							 1.0 / 256.0,
							 1.0 / 256.0,
							 1.0 / 256.0);
	vec4 comp = fract(depth * bitSh);
	comp -= comp.xxyz * bitMsk;
	return comp;
}

void main() {
	const vec4 bitShift = vec4(1.0, 256.0, 256.0 * 256.0, 256.0 * 256.0 * 256.0);
    const vec4 bitMask = vec4(1.0/256.0, 1.0/256.0, 1.0/256.0, 0.0);
  	vec4 rgbaDepth = fract(gl_FragCoord.z * bitShift); // Calculate the value stored into each byte
	rgbaDepth -= rgbaDepth.gbaa * bitMask;  // Cut off the value which do not fit in 8 bits
  	gl_FragColor = rgbaDepth;
  
	// the depth
	//float normalizedDistance  = vPosition.z / vPosition.w;
	//normalizedDistance = (normalizedDistance + 1.0) / 2.0;
	
	// bias
	//normalizedDistance += 0.0005;

	// pack value into 32-bit RGBA texture
	//gl_FragColor = pack(normalizedDistance);
	
}