uniform mat4 uMV;
uniform mat4 uMVP;
uniform mat4 uNormalMatrix;

uniform int uTextureAvailable;

uniform mat4 uShadowProjMatrix;
uniform int uShadowEnabled;

attribute vec4 aPosition;
attribute vec3 aNormal;
attribute vec2 aTexCoord;  
attribute vec4 aColour;

varying vec2 vTexCoord;

varying vec3 vNormal;
varying vec3 vEyeVec;
varying vec4 vPositionFromLight;


void main()                    
{                        
	vec4 worldPosition = uMV * aPosition;
	   
	vTexCoord = aTexCoord;
 
    vNormal = aNormal;
    
    if( uShadowEnabled == 1 ){		
		vPositionFromLight = uShadowProjMatrix * aPosition;		
    } else{
		vPositionFromLight = vec4(0,0,0,0);    
    }    
    	  	  
    gl_Position = uMVP * aPosition;    
}          