package com.wmp.nofrills3d.animations;


public class AnimationClipSequence {

	protected AnimationClip animationClip = null; 
	
	public boolean looping = true;
	
	public float speed = 0.5f; 
	
	public String tag = ""; 
	
	protected float startTime = 0.0f; 
	
	protected float endTime = 0.0f;		
	
	public AnimationClipSequence(AnimationClip animationClip){
		this.animationClip = animationClip;
		this.startTime = 0.0f; 
		this.endTime = animationClip.getDuration(); 
	}
	
	public AnimationClipSequence(AnimationClip animationClip, int startFrame, int endFrame){
		this(animationClip);
		
		this.startTime = this.animationClip.getKeyframeAtIndex(startFrame).time;
		this.endTime = this.animationClip.getKeyframeAtIndex(endFrame).time;		
	}
	
	public AnimationClipSequence(AnimationClip animationClip, float startTime, float endTime){
		this(animationClip);
		
		this.startTime = startTime; 
		this.endTime = endTime; 				         
	}
	
	public float getDuration(){
		return this.endTime - this.startTime; 
	}
	
}
