/**
 * Keyframe.java (NoFrills3D)
 * Created by Joshua Newnham on Apr 29, 2013.
 * Copyright (c) 2013 We Make Play All rights reserved.
 */
package com.wmp.nofrills3d.animations;

import com.wmp.nofrills3d.geometry.Bone;

public class Keyframe implements Comparable<Keyframe>{

	public Bone bone = null; 
	
	public float[] transform = null; 
	
	public float time = 0.0f;
	
	// additional meta data 
	
	public Keyframe previousKeyframe; 
	
	public Keyframe nextKeyframe;
	
	public boolean isLastKeyframe = false; 
	
	// 
	
	public Keyframe(){
		
	}
	
	public Keyframe(Bone bone, float[] transform, float time){
		this.bone = bone; 
		this.transform = transform; 
		this.time = time; 
	}
	
	public void copyTransform(float[] otherTransform){
		for( int i=0; i<16; i++ ){
			otherTransform[i] = transform[i];
		}
	}

	/* (non-Javadoc)
	 * @see java.lang.Comparable#compareTo(java.lang.Object)
	 */
	@Override
	public int compareTo(Keyframe other) {
		if( this.time < other.time ){
			return -1; 
		} else if( this.time > other.time ){
			return 1; 
		} else{
			return 0; 
		}
	}
}
