/**
 * NoFrills3D
 * com.wmp.nofrills3d.effects
 * 
 * @author Joshua Newnham
 * @copyright We Make Play Ltd. 2013 
 * 
 */
package com.wmp.nofrills3d.effects;

import com.wmp.nofrills3d.material.Shader;
import com.wmp.nofrills3d.material.Texture;
import com.wmp.nofrills3d.utils.ContentLoader;

/**
 * 
 */
public abstract class Effect {
	
	protected Shader shader;
	
	protected Texture texture; 
	
	public Effect(Shader shader, int width, int height){
		this.shader = shader; 
		
		this.texture = ContentLoader.createTexture(width, height);
	}	

	abstract void process(Texture input);
	
	public Texture getOutput(){
		return texture; 
	}
	
	public void dispose(){
		if( this.texture != null ){
			this.texture.dispose(); 
			this.texture = null; 
		}
		
		if( this.shader != null ){
			this.shader.dispose(); 
			this.shader = null; 
		}
	}
	
}
