/**
 * OrthographicCamera.java (ColourExplosion)
 * Created by Joshua Newnham on Apr 9, 2013.
 * Copyright (c) 2013 We Make Play All rights reserved.
 */
package com.wmp.nofrills3d.entities;

import com.wmp.nofrills3d.math.Matrix4;

public class OrthographicCamera extends Camera {

	public float near = 1f; 
	
	public float far = 100.0f; 
	
	public float scale = 2.0f; 
	
	public OrthographicCamera(){
		super(); 
	}
	
	@Override
	public boolean init() {
		if (viewWidth <= 0 || viewHeight <= 0) {
			return false;
		}

		final float aspectRatio = viewWidth > viewHeight ? (float) viewWidth
				/ (float) viewHeight : (float) viewHeight / (float) viewWidth;

		if (viewWidth > viewHeight) {
			// Landscape
			projectionMatrix = Matrix4.createOrthographic(
					-aspectRatio * scale,
					aspectRatio * scale, 
					-1f * scale, 
					1f * scale, 
					near, far);
		} else {
			// Portrait or square
			projectionMatrix = Matrix4.createOrthographic(
					-1f * scale, 
					1f * scale,
					-aspectRatio * scale, 
					aspectRatio * scale, 
					near, far);
		}

		return true;
	}
	
	public void setScale(float scale){
		this.scale = scale; 
		
		init(); 
	}
}
