/**
 * ProjectiveCamera.java (ColourExplosion)
 * Created by Joshua Newnham on Apr 9, 2013.
 * Copyright (c) 2013 We Make Play All rights reserved.
 */
package com.wmp.nofrills3d.entities;

import com.wmp.nofrills3d.math.Matrix4;

public class ProjectiveCamera extends Camera {

	public float near = 1f; 
	
	public float far = 200.0f; 
	
	public float fovInDeg = 45.0f; 
	
	public ProjectiveCamera(){
		super(); 
	}
	
	public ProjectiveCamera(float fov, float near, float far){
		this.fovInDeg = fov; 
		this.near = near; 
		this.far = far; 
	}
	
	@Override 
	public boolean init(){
		if( viewWidth <= 0 || viewHeight <= 0 ){
			return false; 
		}
		
		projectionMatrix = Matrix4.createPerspective(fovInDeg, (float)viewWidth/(float)viewHeight, near, far);
		
		return true; 
	}
	
}
