/**
 * CAnimation.java (NoFrills3D)
 * Created by Joshua Newnham on Apr 29, 2013.
 * Copyright (c) 2013 We Make Play All rights reserved.
 */
package com.wmp.nofrills3d.entities.loaders.collada;

import java.util.List;
import java.util.Vector;

import com.wmp.nofrills3d.entities.loaders.collada.COLLADAModelLoader.CSourceSemantic;

public class CAnimation {

	public String id = "";
	public int length = 0;
	public List<CSource> sources = new Vector<CSource>(3); 
	
	// channel properties 
	public String target = ""; // expecting format <BONE>/<CHANNEL>
	
	public String bone = ""; 
	public String channel = ""; // only handling 'transform'
	
	// short-cuts 
	public CSource timeSource; // references a CSource object in sources
	public CSource transformSource; // references a CSource object in sources 
	
	public CAnimation(){
		
	}
	
	public CSource findInputWithSourceId(String id){
		for(CSource source : sources ){
			if( source !=null && source.id.equals(id) ){
				return source; 
			}
		}
		return null; 
	}
	
	public CSource findInputWithSourceType(CSourceSemantic type){
		for(CSource source : sources ){
			if( source !=null && source.type == type ){
				return source; 
			}
		}
		
		return null; 
	}
	
	@Override
	public String toString(){
		StringBuffer sb = new StringBuffer(); 
		
		sb.append(String.format("<animation :: id='%s'>", this.id));				
		
		sb.append(timeSource.toString());
		sb.append(transformSource.toString());
		
		sb.append("</animation>");
		
		return sb.toString(); 
	}
		
}
