/**
 * CGeometry.java (NoFrills3D)
 * Created by Joshua Newnham on Apr 16, 2013.
 * Copyright (c) 2013 We Make Play All rights reserved.
 */
package com.wmp.nofrills3d.entities.loaders.collada;

import java.util.List;
import java.util.Vector;

import com.wmp.nofrills3d.entities.loaders.collada.COLLADAModelLoader.CSourceSemantic;
import com.wmp.nofrills3d.geometry.Bone;

public class CGeometry {
	public String id = ""; 
	public String name = "";
	public CPolyList polyList; 
	public List<CSource> sources = new Vector<CSource>(3); // vertices, normals, texture coords 
	
	public CSkin skin = null; 
	
	public Bone rootBone = null; 
	
	public CGeometry(){
		
	}
	
	public boolean hasSourceOfType(CSourceSemantic type){
		for( CSource source : sources ){
			if( source.type == type ){
				return true; 
			}
		}
		
		return false; 
	}
	
	public CSource findSourceOfType(CSourceSemantic type){
		for( CSource source : sources ){
			if( source.type == type ){
				return source; 
			}
		}
		
		return null; 
	}
	
	public int getSourceLength(){
		int size = 0;
		
		for( CSource source : sources ){
			size += source.getSize(); 
		}
		
		return size; 
	}
	
	public boolean hasIndicies(){
		return polyList != null; 
	}
	
	public int getStride(){
		int stride = 0;
		
		for( CSource source : sources ){
			stride += source.stride;
		}
		
		return stride; 
	}
}
