/**
 * CSkin.java (NoFrills3D)
 * Created by Joshua Newnham on Apr 23, 2013.
 * Copyright (c) 2013 We Make Play All rights reserved.
 */
package com.wmp.nofrills3d.entities.loaders.collada;

import java.util.List;
import java.util.Vector;

import com.wmp.nofrills3d.entities.loaders.collada.COLLADAModelLoader.CSourceSemantic;
import com.wmp.nofrills3d.math.Matrix4;

public class CSkin {

	public String id = "";
	
	public String name = "";
	
	public Matrix4 bindShapeMatrix = Matrix4.createIdentity(); 
	
	public List<CSource> sources = new Vector<CSource>(2); 
	
	public CVertexBoneInfluence[] vertexBoneInfluences = null; 
	
	public CSkin(){
		
	}
	
	public boolean hasSourceOfType(CSourceSemantic type){
		for( CSource source : sources ){
			if( source.type == type ){
				return true; 
			}
		}
		
		return false; 
	}
	
	public CSource findSourceOfType(CSourceSemantic type){
		for( CSource source : sources ){
			if( source.type == type ){
				return source; 
			}
		}
		
		return null; 
	}
	
	public CSource findSourceWithId(String id){
		id = id.replace("#", "");
		for( CSource source : sources ){
			if( source.id.equals(id) ){
				return source; 
			}
		}
		
		return null; 
	}
	
	public int getVertexBoneInfluencesLength(){
		if( vertexBoneInfluences != null ){
			return vertexBoneInfluences.length * CConstants.BONE_INFLUENCE_LIMIT; 
		}
		
		return 0; 
	}
	
}
