/**
 * CSource.java (NoFrills3D)
 * Created by Joshua Newnham on Apr 16, 2013.
 * Copyright (c) 2013 We Make Play All rights reserved.
 */
package com.wmp.nofrills3d.entities.loaders.collada;

import com.wmp.nofrills3d.entities.loaders.collada.COLLADAModelLoader.CDataTypeEnum;
import com.wmp.nofrills3d.entities.loaders.collada.COLLADAModelLoader.CSourceSemantic;

public class CSource {

	public String id= "";
	
	public float[] dataAsFloat; 
	public int[] dataAsInt; 
	public String[] dataAsString; 
	public int length = 0;
	
	public CSourceParam[] params = null; 
	public int nextParamIndex = 0; 
	
	CDataTypeEnum dataType; 
	
	public int count = 0;
	public int stride = 0; 
	
	public CSourceSemantic type = CSourceSemantic.Undefined; 	
	
	public CSource(){
		
	}		
	
	public int getSize(){
		return count * stride; 
	}
	
	public CSourceParam findParameterWithName(String name){
		if( params != null ){
			for( CSourceParam param : params ){
				if( param.name.equals(name) ){
					return param; 
				}
			}
		}
		
		return null; 
	}
	
	@Override
	public String toString(){
		StringBuffer sb = new StringBuffer(); 
		
		sb.append(String.format("<source id='%s' length='%d' count='%d' stride='%d'>", id, length, count, stride));
		
		sb.append("<data>");
		
		if( dataAsFloat != null ){
			for( int i=0; i<dataAsFloat.length; i++ ){
				sb.append(dataAsFloat[i]);
			}
		}
		
		if( dataAsInt != null ){
			for( int i=0; i<dataAsInt.length; i++ ){
				sb.append(dataAsInt[i]);
			}
		}
		
		if( dataAsString != null ){
			for( int i=0; i<dataAsString.length; i++ ){
				sb.append(dataAsString[i]);
			}
		}
		
		sb.append("</data>");
		
		return sb.toString(); 
	}
	
}
