/**
 * IMesh.java (NoFrills3D)
 * Created by Joshua Newnham on Apr 12, 2013.
 * Copyright (c) 2013 We Make Play All rights reserved.
 */
package com.wmp.nofrills3d.geometry;

import com.wmp.nofrills3d.material.Material;
import com.wmp.nofrills3d.physics.BoxCollider;

public interface IMesh {

	public static final int FLOAT_SIZE_BYTES = 4;
	public static final int INT_SIZE_BYTES = 4;
	public static final int SHORT_SIZE_BYTES = 2;
	
	public String getTag(); 
	
	public void bind(Material material);
	
	public void draw();
	
	public void unbind(Material material);
	
	public void dispose();
	
	public void pushVertexDefinition(VertexDefinition... vd);
	
	public void setVertexData(float[] data);
	
	public void setIndiciesData(short[] data);	
	
	public BoxCollider getBoundingBox(); 
}
