package com.wmp.nofrills3d.input;

import android.view.KeyEvent;
import android.view.MotionEvent;

public class UserInputEvent {

	public enum EventTypeEnum{
		Undefined, 
		Key, 
		Touch
	}
	
	public enum EventActionEnum{
		Undefined, 
		Down, 
		Moved, 
		Up
	}
	
	public int id = -1; 
	
	public EventTypeEnum type = EventTypeEnum.Undefined; 
	
	public EventActionEnum action = EventActionEnum.Undefined; 
	
	public float x = 0.0f; 
	
	public float y = 0.0f; 
	
	public long time = 0; 
	
	public float pressure = 0.0f; 
	
	public UserInputEvent(){
		
	}
	
	public void initWithEvent(KeyEvent event) {
		type = EventTypeEnum.Key;
		int a = event.getAction();
		switch (a) {
		case KeyEvent.ACTION_DOWN:
			action = EventActionEnum.Down;
			break;
		case KeyEvent.ACTION_UP:
			action = EventActionEnum.Up;
			break;
		default:
			action = EventActionEnum.Undefined;
		}
		time = event.getEventTime();
		id = event.getKeyCode();
	}

	public void initWithEvent(MotionEvent event) {
		type = EventTypeEnum.Touch;
		
		int pointerIndex = (event.getAction() & MotionEvent.ACTION_POINTER_INDEX_MASK) >> MotionEvent.ACTION_POINTER_INDEX_SHIFT;
                		
		int a = event.getAction();
		
		switch (a & MotionEvent.ACTION_MASK) {
		case MotionEvent.ACTION_DOWN:
			action = EventActionEnum.Down;
		break;
		case MotionEvent.ACTION_MOVE:
			action = EventActionEnum.Moved;
			break;
		case MotionEvent.ACTION_UP:
			action = EventActionEnum.Up;
			break;
		default:
			action = EventActionEnum.Undefined;
		}
		
		id = pointerIndex; 
		time = event.getEventTime();
		x = event.getX();
		y = event.getY();
		pressure = event.getPressure();
	}

	public void initWithEventHistory(MotionEvent event, int historyItem) {
		type = EventTypeEnum.Touch;
		
		int pointerIndex = (event.getAction() & MotionEvent.ACTION_POINTER_INDEX_MASK) >> MotionEvent.ACTION_POINTER_INDEX_SHIFT;
                		
		action = EventActionEnum.Moved;
		
		id = pointerIndex; 
		time = event.getHistoricalEventTime(historyItem);
		x = event.getHistoricalX(historyItem);
		y = event.getHistoricalY(historyItem);
		//pressure = event.getPressure(historyItem);		
	}
}
