package com.wmp.nofrills3d.material;

import android.annotation.SuppressLint;

@SuppressLint("DefaultLocale")
public class Colour {

	public static final int R = 0;
	public static final int G = 1;
	public static final int B = 2;
	public static final int A = 3;
		
	public float[] colour = new float[]{1f,1f,1f,1f}; 	
	
	public Colour(float r, float g, float b, float a){
		colour[R] = r; 
		colour[G] = g;
		colour[B] = b;
		colour[A] = a;
	}
	
	public Colour(float r, float g, float b){
		this(r, g, b, 1.0f);
	}
	
	public Colour(int r, int g, int b, int a){
		this((float)r/255.0f, (float)g/255.0f, (float)b/255.0f, (float)a/255.0f);
	}
	
	public Colour(int r, int g, int b){
		this((float)r/255.0f, (float)g/255.0f, (float)b/255.0f, 1.0f);
	}
	
	public Colour(byte r, byte g, byte b, byte a){
		this((float)r/255.0f, (float)g/255.0f, (float)b/255.0f, (float)a/255.0f);
	}
	
	public Colour(byte r, byte g, byte b){
		this((float)r/255.0f, (float)g/255.0f, (float)b/255.0f, 1.0f);
	}
	
	public Colour(long packedColour){
		this( 
				(byte)packedColour, 
				(byte)(packedColour >> 8), 
				(byte)(packedColour >> 16), 
				(byte)(packedColour >> 24)
			);		
	}
	
	public float getR(){
		return colour[R]; 
	}
	
	public void setR(float val){
		colour[R] = val; 
	}
	
	public float getG(){
		return colour[G]; 
	}
	
	public void setG(float val){
		colour[G] = val; 
	}
	
	public float getB(){
		return colour[B]; 
	}
	
	public void setB(float val){
		colour[B] = val; 
	}
	
	public float getA(){
		return colour[A]; 
	}
	
	public void setA(float val){
		colour[A] = val; 
	}
	
	public void setRGB(float r, float g, float b){
		colour[R] = r; 
		colour[G] = g;
		colour[B] = b;
	}
	
	public void setRGBA(float r, float g, float b, float a){
		colour[R] = r; 
		colour[G] = g;
		colour[B] = b;
		colour[A] = a;
	}
	
	@Override
	public String toString(){
		return String.format("C(%f, %f, %f, %f)", colour[R], colour[B], colour[G], colour[A]);
	}
	
	public static final Colour create(float r, float g, float b, float a){
		return new Colour(r, g, b, a);
	}
	
	public static final Colour create(float r, float g, float b){
		return new Colour(r, g, b);
	}
	
	public static final Colour create(int r, int g, int b, int a){
		return new Colour(r, g, b, a);
	}
	
	public static final Colour create(int r, int g, int b){
		return new Colour(r, g, b);
	}
	
	public static final Colour create(byte r, byte g, byte b, byte a){
		return new Colour(r, g, b, a);
	}
	
	public static final Colour create(byte r, byte g, byte b){
		return new Colour(r, g, b);
	}
}
