/**
 * NoFrills3D
 * com.wmp.nofrills3d.material
 * 
 * @author Joshua Newnham
 * @copyright We Make Play Ltd. 2013 
 * 
 */
package com.wmp.nofrills3d.material;

import com.wmp.nofrills3d.math.Vector3;


/**
 * 
 */
public class Light {
	
	public float[] lightPosition = new float[]{
			2.0f, 10.0f, 5.0f, 1.0f,		// position
			0.0f, 0.0f, 0.0f, 				// center (where the light is looking at)
			0.0f, 1.0f, 0.0f}; 				// up vector
			  	
	public Colour ambient = Colour.create(0.1f, 0.1f, 0.1f, 1f);
	
	public Colour diffuse = Colour.create(0.2f, 0.2f, 0.2f, 1.0f);
	
	public Colour specular = Colour.create(0.0f, 0.0f, 0.0f, 1.0f);
	
	public boolean enabled = true; 
	
	public Light(){
		
	}
	
	public void setLightPosition(Vector3 position){
		this.setLightPosition(position.x, position.y, position.z);
	}
	
	public void setLightPosition(float x, float y, float z){
		lightPosition[0] = x; 
		lightPosition[1] = y;
		lightPosition[2] = z;
	}
	
	public void setLightTarget(Vector3 position){
		this.setLightTarget(position.x, position.y, position.z);
	}
	
	public void setLightTarget(float x, float y, float z){
		lightPosition[3] = x; 
		lightPosition[4] = y;
		lightPosition[5] = z;
	}

}
