/**
 * Vector2.java (ColourExplosion)
 * Created by Joshua Newnham on Apr 9, 2013.
 * Copyright (c) 2013 We Make Play All rights reserved.
 */
package com.wmp.nofrills3d.math;

public class Vector2 {
	
	public static Vector2 Zero(){ return new Vector2(); }
	
	public static Vector2 One(){ return new Vector2(1,1); }
	
	public static Vector2 Subtract( Vector2 v1, Vector2 v2 ){
		return new Vector2(v1.x - v2.x, v1.y - v2.y);
	}
	
	public static Vector2 Add( Vector2 v1, Vector2 v2 ){
		return new Vector2(v1.x + v2.x, v1.y + v2.y);
	}
	
	public static Vector2 Scale( Vector2 v1, float scale ){
		return new Vector2(v1.x * scale, v1.y * scale);
	}
	
	public float x; 
	public float y; 
	
	protected float[] vector = new float[2]; 
	
	public Vector2(){
		this.x = 0; this.y = 0; 
	}
	
	public Vector2(float x, float y){
		this.x = x; this.y = y; 
	}		
	
	public void normalise(){
		float len = length(); 
		this.x = this.x / len; 
		this.y = this.y / len; 
	}
	
	public float length(){
		return (float)Math.sqrt(x * x + y * y);		
	}
	
	public float lengthSqr(){
		return x * x + y * y;		
	}
	
	public void scale(float scale){
		this.x *= scale;
		this.y *= scale; 
	}	
	
	public float[] getFloatArray(){
		vector[0] = x; 
		vector[1] = y; 
		return vector; 
	}
}
