package com.wmp.nofrills3d.physics;

import com.wmp.nofrills3d.math.Vector3;

public class Contact {

	public enum ContainmentType
    {
        Disjoint,
        Contains,
        Intersects
    }	
	
	public Vector3 contactPoint = Vector3.createZero(); 
	
	public ContainmentType containmentType = ContainmentType.Disjoint;
	
	public ICollider colliderA = null;
	
	public ICollider colliderB = null; 	
	
	public float distance = 0.0f; 
	
	public Contact(){
		
	}
	
	public Contact(ICollider colliderA, ICollider colliderB){
		this.colliderA = colliderA; 
		this.colliderB = colliderB; 
	}
	
	public Contact(ICollider colliderA, ICollider colliderB, ContainmentType containtmentType){
		this.colliderA = colliderA; 
		this.colliderB = colliderB;
		this.containmentType = containtmentType; 
	}
	
	public Contact(ICollider colliderA, ICollider colliderB, ContainmentType containtmentType, Vector3 point){
		this.colliderA = colliderA; 
		this.colliderB = colliderB;
		this.containmentType = containtmentType;
		this.contactPoint = point; 
	}
}
