package com.wmp.nofrills3d.physics;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Iterator;

import com.wmp.nofrills3d.utils.Logger;

public class ContactCollection implements Iterable<Contact> {

	public static final String TAG = "ContactCollection";
	
	private final ArrayList<Contact> results = new ArrayList<Contact>();
	
    public void clear(){
        results.clear();
    }

    @Override
    public Iterator<Contact> iterator() {
       return results.iterator();
    }

    public void addContact(Contact result){
        results.add(result);
    }

    public int size(){
        return results.size();
    }

    public Contact getClosestContact(){
    	if( Logger.Logging ){
			Logger.LogTODO(TAG, "getClosestCollision() incomplete");
		}
        return null; 
    }

    public Contact getFarthestContact(){
    	if( Logger.Logging ){
			Logger.LogTODO(TAG, "getFarthestCollision() incomplete");
		}
        return null;
    }

    public Contact getContact(int index){
        return results.get(index);
    }

    @Override
    public String toString(){
        StringBuilder sb = new StringBuilder();
        sb.append("CollisionResults[");
        
        for (Contact result : results){
            sb.append(result).append(", ");
        }
        if (results.size() > 0)
            sb.setLength(sb.length()-2);

        sb.append("]");
        return sb.toString();
    }
    
    public void sort(){
    	if( results == null || results.size() == 0 ){
    		return; 
    	}
    	
    	Collections.sort(results, new ContactComparable());
    }
    
    public class ContactComparable implements Comparator<Contact>{
    	 
        @Override
        public int compare(Contact o1, Contact o2) {
            return (o1.distance > o2.distance ? -1 : (o1.distance == o2.distance ? 0 : 1));
        }
    }

}
