/**
 * Collider.java (NoFrills3D)
 * Created by Joshua Newnham on Apr 22, 2013.
 * Copyright (c) 2013 We Make Play All rights reserved.
 */
package com.wmp.nofrills3d.physics;

import com.wmp.nofrills3d.entities.Transform;

public interface ICollider extends ICollidable {

	public static final int COLLIDER_TYPE_BOX 			= 0; 
	public static final int COLLIDER_TYPE_SPHERE 		= 1;
	public static final int COLLIDER_TYPE_RAY			= 2;
	public static final int COLLIDER_TYPE_COLLECTION	= 3; 
			
	String getTag();
	
	void setTransform(Transform transform);
	
	Transform getTransform(); 
	
	int getColliderType(); 		
	
	void update(float elapsedTime);
	
	
}
