/**
 * Scene.java (WMP3D)
 * Created by Joshua Newnham on Apr 10, 2013.
 * Copyright (c) 2013 We Make Play All rights reserved.
 */
package com.wmp.nofrills3d.scene;

import java.util.Iterator;

import com.wmp.nofrills3d.effects.RenderTarget;
import com.wmp.nofrills3d.effects.TextureRenderer;
import com.wmp.nofrills3d.entities.Camera;
import com.wmp.nofrills3d.entities.Entity;
import com.wmp.nofrills3d.material.Texture;
import com.wmp.nofrills3d.math.Ray;

public interface IScene {
	
	void setCamera(Camera camera);
	
	Camera getCamera(); 
	
	void setSceneRenderer(SceneRenderer renderer);
	
	SceneRenderer getSceneRenderer(); 
	
	void addEntity(Entity entity);
	
	void removeEntity(Entity entity);
	
	Entity findEntityWithTag(String tag);
	
	Iterator<Entity> getEntityIterator();			
	
	Ray screenPositionToRay(float x, float y);
	
	void onSceneRendererSurfaceChanged(SceneRenderer renderer, int viewWidth, int viewHeight);
	
	void onUpdate(float elapsedTime);
	
	void onRender();
	
	void flush(); 
	
	void setShadowsEnabled(boolean shadowsEnabled);
	
	boolean isShadowsEnabled();
	
	RenderTarget getShadowRenderTarget(); 
	
}
